#!/usr/bin/perl -w

# This is the package TextureList. It handles the creation of a
# texture list that can be used to create a Texture object for
# inclusion in a mission.

# (c) Copyright by Wes Morrison 2000. All Rights Reserved.

# [12/06/2000] v0.0.1 - new

package Cowgen::TextureList;

require Exporter;
@ISA     = qw(Exporter);

use Cowgen::Dromed;
use Data::Dumper;

my $VERSION = 0.01;

# this is bad!
#my $texcount = 0;
#my $texnum = {};

sub create { 
  my $s = {};
  my @tex;
  shift;
  my $mistextures = shift;
  if(defined($mistextures)){
   foreach $tmp (keys %$mistextures){
    (my $t1,$t2,$t3,$t4,$t5,$t6)=split(';',$mistextures->{$tmp});
    if($tmp<247){
     @tex[$tmp-1]=$t6;
    }
   }
  }
  $s->{textures} = \@tex;

#print Dumper(@tex);
#print "Press enter to continue\n";
#<STDIN>;

  bless $s;
  #$texnum = {};  
  return $s;
}

sub DESTROY
  {
  # no cleanup needed 
  # print "destroyed!\n";
  }

sub texture {
  $self = shift;

  my $texname = lc(shift);

  if($texname eq ''){
   return jorge();
  }

  my $numtex=scalar(@{$self->{textures}});

  # Is this texture present? If not, add it.
  for(my $i=0; $i<$numtex; $i++){
   if($texname eq $self->{textures}[$i]){
    return $i+1;
   }
  }
  if ($numtex >= 245) {
   print "Too many textures, using jorge()\n";
   return jorge();
  }else{
   $self->{textures}[scalar(@{$self->{textures}})] = $texname;
   return $numtex+1;
  }
  return jorge();
}

1;

