require Data::Dumper;
use Data::Dumper;

$scriptHash={};

$dir='./Cow/MetaBrush/scripts';

opendir(DIR, $dir) || die "can't opendir $dir: $!";
while($_=readdir(DIR)){
 my $subdir="$dir/$_";
 if(!/^\./ && -d $subdir){
  my $type=$_;
  $scriptHash->{$type}={};
  opendir(SUBDIR, $subdir) || die "can't opendir $subdir: $!";
  while($_=readdir(SUBDIR)){
   if(!/^\./ && -f "$subdir/$_"){
    next if(/$Copy of/ || /\.bak$/ || /\.gif$/);
    open(FILE,"<$subdir/$_") or next;
    my $description=$_;
    my $script=$_;
    while(<FILE>){
     if(/^#description:/){
      ($tmp,$description)=split(':');
      $description=trim($description);
     }
    }
    close(FILE);
    next if($description eq 'skip_me');
    $scriptHash->{$type}->{$script}=$description; # What about duplicate descriptions?
   }
  }
  closedir SUBDIR;
 }
}
closedir DIR;

$Data::Dumper::Indent=1;
$Data::Dumper::Varname='scriptHash';
open FILE,">scriptHash.txt" or die "Can't create script config file 'scriptHash.txt'!\n";
print FILE Dumper($scriptHash);
close FILE;

sub trim {
 {
  my $tmp=shift;
  $tmp=~s/^\s+//;
  $tmp=~s/\s+$//;
  $tmp;
 }
}
